/*
   video.cpp

   ZORAN ZR36120 module driver.
   Copyright (C) 1997  Vincent Labie (try ivsparis@pratique.fr with
				      for Vincent Labie in the suject)

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

	// the X11 code is not that clean, say... buggy, do copy/paste with care! :)
#include	"video.h"

#define		ZORAN_CAPMODE		ZORAN_CAPMODE_3CONTINOUS

/*************************************************************************************************/

int			width		=TV_WIDTH;
int			height		=TV_HEIGHT;
int			ZoranNB		=0;
int			bScale		=0;
int			bContinous	=0;
int			bMITShm		=0;
int			bOscillo	=0;
int			bYUV		=0;
int			bColorYUV	=1;
int			Input		=ZORAN_CVBS2;	// rca? hardware dependant
int			Standart	=ZORAN_PAL;
int			Brightness	=210;
int			Chroma		=127;
int			Contrast	=102;
int			Hue		=15;
int			UVGain		=-12;

Window			win,root;

int			hScreen;
unsigned long		Black,White;
	
XEvent			ev;
Display *		dpy;
Visual *		visual;
int			depth;
int			colorbytes;
Status			status;
XImage *		pXImage		=NULL;
char *			XImageData	=NULL;
XShmSegmentInfo 	shmInfo;
GC			gc;
XGCValues		gcv;
unsigned long		gcmask;

char *			pScreen;
ZR_CAP_PARAMS		ZRCapParams;

unsigned long		NbFrameDrawn	=0;
unsigned long		StartTime	=0;
unsigned long		TimeWindow	=5000;
int			fd		=-1;
int			Err		=0;
int			bGrabMode	=FALSE;

/*************************************************************************************************/
/*************************************************************************************************/
void		OpenWindow(void)
{
	hScreen		=DefaultScreen(dpy);
	visual		=DefaultVisual(dpy,0);
	depth		=DefaultDepth(dpy,0);
	colorbytes	=(depth+7)>>3;
	root		=DefaultRootWindow(dpy);
	Black		=BlackPixel(dpy,hScreen);
	White		=WhitePixel(dpy,hScreen);

	win=XCreateSimpleWindow(dpy,root,0,0,width,height,0,Black,White);
	XSelectInput(dpy,win,		KeyPressMask|
					Button1MotionMask|
					ButtonPressMask|
					ButtonReleaseMask);

	XMapWindow(dpy,win);
	gcv.foreground	=Black^White;
	gcv.background	=White;
	gcv.line_width	=2;
	gcv.function	=GXcopy;
	gcmask		=GCForeground|GCBackground|GCLineWidth|GCFunction;
	gc=XCreateGC(dpy,win,gcmask,&gcv);
	if (bMITShm)
		{
		XStoreName(dpy,win,"MITSHM");

		pXImage=XShmCreateImage(dpy,visual,DefaultDepth(dpy,DefaultScreen(dpy)),
					ZPixmap,NULL,&shmInfo,width,height);
		shmInfo.shmid=shmget(IPC_PRIVATE,pXImage->bytes_per_line*height,IPC_CREAT|0777);
		if (shmInfo.shmid<0)
			{ fprintf(stderr,"Error with MIT-SHM shmget\n");
			exit(1); }
		XImageData=shmInfo.shmaddr=pXImage->data=shmat(shmInfo.shmid,0,0);
		if ((char*)pXImage->data==(char*)-1) { fprintf(stderr,"error: shmat\n"); exit(1); }
		shmInfo.readOnly=False;
		if (!XShmAttach(dpy,&shmInfo)) { fprintf(stderr,"error: XShmAttach\n"); exit(1); }
		}
	else	{
		XStoreName(dpy,win,"XImage");

		pXImage=XCreateImage(dpy,visual,depth,ZPixmap,0,NULL,width,height,32,0);
		XImageData=pXImage->data=(char*)malloc(pXImage->bytes_per_line*height);
		}
	if (colorbytes==3)
		{ colorbytes=pXImage->bytes_per_line/width;	// the only way i found to get the REAL
		depth=colorbytes*8; }				// depth of screen in 24/32bpp :\

}

/*************************************************************************************************/
/*************************************************************************************************/
void		CloseWindow(void)
{
	if (pXImage!=NULL);
		{
		pXImage->data=XImageData;
		if (bMITShm)
			{ XShmDetach(dpy,&shmInfo); XDestroyImage(pXImage);
			shmdt(shmInfo.shmaddr); shmctl(shmInfo.shmid,IPC_RMID,0); }
		else	XDestroyImage(pXImage);
		}

	XCloseDisplay(dpy);
}

/*************************************************************************************************/
/*************************************************************************************************/
int		InitZoran()
{
	char			ZoranDevName[64];
	int			FrameBufferSize;
	char *			pFrameBuffer;

	sprintf(ZoranDevName,"/dev/zoran%d",ZoranNB);
	if ((fd=open(ZoranDevName,O_RDONLY))<0)
		{ printf("open %s failed\n",ZoranDevName); perror("open"); return(FALSE); }

	memset(&ZRCapParams,0,sizeof(ZRCapParams));

	ZRCapParams.CapWidth		=width;
	ZRCapParams.CapHeight		=height;
	ZRCapParams.CapScanLineSize	=pXImage->bytes_per_line;
	ZRCapParams.ZRReduceMode	=(bScale)?ZRM_SCALE:ZRM_CROP;
	if (ZRCapParams.CapScanLineSize&0x03)
		{ printf("CapScanLineSize is not DWORD aligned!.\n"); return(FALSE); }
	FrameBufferSize=pXImage->bytes_per_line*height*3;

	if (bYUV)	// can only be used in 15/16bpp because the in/out buffer have the same size.
		ZRCapParams.ZRPixel		=ZPX_YUV422;
	else	{
	switch(depth)
			{
			case 15:
				ZRCapParams.ZRPixel=ZPX_RGB555;
				break;
			case 16:
				ZRCapParams.ZRPixel=ZPX_RGB565;
				break;
			case 24:
				ZRCapParams.ZRPixel=ZPX_RGB888_PACK24;
				break;
			case 32:
				ZRCapParams.ZRPixel=ZPX_RGB888_PACK32;
				break;
			default:
				printf("Unsupported depth.\n");
				return(FALSE);
			}
		}

	printf(	"input: DisplayCells=%i, DisplayPlanes=%i, depth=%i, "
		"width=%i * height=%i * colorbytes=%i * nbslot=%i => framebuffersize=%i\n",
		DisplayCells(dpy,hScreen),DisplayPlanes(dpy,hScreen),depth,
		width,height,colorbytes,3,FrameBufferSize);

	ZRCapParams.ZREndian		=ZEN_LITTLEENDIAN;
	ZRCapParams.ZRField		=ZFI_NORMAL;
	ZRCapParams.ZRHFilter		=ZHF_NONE;//ZHF_4L4C;//
	ZRCapParams.ZRErrDif		=ZED_NONE;//ZED_ACTIVE;//
	ZRCapParams.NbSlot		=3;
	if ((Err=ioctl(fd,ZORAN_CAP_PARAMS,&ZRCapParams))<0)
		{ printf("ioctl ZORAN_CAP_PARAMS %i.\n",Err); perror("ioctl"); return(FALSE); }
	if ((Err=ioctl(fd,Input,Standart))<0)
		{ printf("ioctl %i => %i.\n",Input,Err); perror("ioctl"); return(FALSE); }

/*	if (ioctl(fd,ZORAN_BRIGHTNESS,Brightness)<0)
		{ printf("\nzoran: unable to set brightness.\n"); return(FALSE); }
	printf("bright %i ",Brightness);

	if (ioctl(fd,ZORAN_SATURATION,Chroma)<0)
		{ printf("\nzoran: unable to set chroma sat.\n"); return(FALSE); }
	printf("chroma %i ",Chroma);

	if (ioctl(fd,ZORAN_CONTRAST,Contrast)<0)
		{ printf("\nzoran: unable to set contrast.\n"); return(FALSE); }
	printf("contrast %i ",Contrast);

	if (ioctl(fd,ZORAN_HUE,Hue)<0)
		{ printf("\nzoran: unable to set hue.\n"); return(FALSE); }
	printf("hue %i ",Hue);

	if (ioctl(fd,ZORAN_GAIN,UVGain)<0)
		{ printf("\nzoran: unable to set uv gain.\n"); return(FALSE); }
	printf("uvgain %i ",UVGain);
	printf("OK.\n");*/

	ChangeChannel();

	pScreen=(char*)mmap((caddr_t)0,FrameBufferSize,
				PROT_READ,MAP_FILE|MAP_SHARED,fd,(off_t)0);
	printf("XImageData=0x%08X, pScreen=0x%08X",(int)XImageData,(int)pScreen);
	if (pScreen==(char*)-1)
		{ printf("mmap failed %i.\n",FrameBufferSize); perror("mmap"); return(FALSE); }

	if (bContinous)
		{ if ((Err=ioctl(fd,ZORAN_CAPMODE_CONTINOUS))<0)
			{ printf("ioctl ZORAN_CAPMODE_CONTINOUS %i.\n",Err); perror("ioctl"); return(FALSE); }
		printf("ioctl ZORAN_CAPMODE_CONTINOUS %i.\n",Err); }
	else	{ if ((Err=ioctl(fd,ZORAN_CAPMODE))<0)
			{ printf("ioctl ZORAN_CAPMODE_3CONTINOUS(G) %i.\n",Err); perror("ioctl"); return(FALSE); }
		printf("ioctl ZORAN_CAPMODE_3CONTINOUS(G) %i.\n",Err); }
	return(TRUE);
}

/*************************************************************************************************/
/*************************************************************************************************/
int		CloseZoran()
{
	if (fd>=0) close(fd);
	return(TRUE);
}

/*************************************************************************************************/
/*************************************************************************************************/
inline	void	SetDstColor(int Red,int Green,int Blue,u_char * & pDst)
{
	u_long			Val;
	switch(depth)
		{
		case 15:
			Red>>=3;	Red&=0x1f;
			Green>>=3;	Green&=0x1f;
			Blue>>=3;	Blue&=0x1f;
			Val=(Blue+(Green<<5)+(Red<<10));
			*pDst=Val;	pDst++;
			*pDst=Val>>8;	pDst++;
			break;
		case 16:
			Red>>=3;	Red&=0x1f;
			Green>>=2;	Green&=0x3f;
			Blue>>=3;	Blue&=0x1f;
			Val=(Blue+(Green<<5)+(Red<<11));
			*pDst=Val;	pDst++;
			*pDst=Val>>8;	pDst++;
			break;
		case 24:
			*pDst=Red;	pDst++;
			*pDst=Green;	pDst++;
			*pDst=Blue;	pDst++;
			break;
		case 32:
			*pDst=Red;	pDst++;
			*pDst=Green;	pDst++;
			*pDst=Blue;	pDst++;
			pDst++;
			break;
		}
}

/*************************************************************************************************/
/*************************************************************************************************/
inline	void	YUV2RGB(const u_char Y,const u_char U,const u_char V,u_char * & pDst)
{
	int			Red,Green,Blue;

/*	really show floating point YUV to RGB convertion
	float		fRed,fBlue,fGreen;
	fBlue=(float)Y+((float)U-128)*1.77;
	fRed=(float)Y+((float)V-128)*1.4;
	fGreen=(float)Y*1.70-fRed*.51-fBlue*.19;
	if (fRed<0) Red=0; else if (fRed>255) Red=255; else Red=(int)fRed;
	if (fBlue<0) Blue=0; else if (fBlue>255) Blue=255; else Blue=(int)fBlue;
	if (fGreen<0) Green=0; else if (fGreen>255) Green=255; else Green=(int)fGreen;
*/
	int			Vred	=(((u_int)V-128)*226*2);
	int			Ublue	=(((u_int)U-128)*179*2);

	Red=((u_int)Y)<<8;		Red+=Vred;					Red>>=8;
	Blue=((u_int)Y)<<8;		Blue+=Ublue;					Blue>>=8;
	Green=(((u_int)Y)*436);	Green-=(Red*130);	Green-=(Blue*50);	Green>>=8;

	if (Green<0)	Green=0;	else if (Green>255)	Green=255;
	if (Blue<0)	Blue=0;		else if (Blue>255)	Blue=255;
	if (Red<0)	Red=0;		else if (Red>255)	Red=255;

	SetDstColor(Red,Green,Blue,pDst);
}

/*************************************************************************************************/
/*************************************************************************************************/
inline	void	Y2BW(u_char Y,const u_char U,const u_char V,u_char * & pDst)
{
	SetDstColor(Y,Y,Y,pDst);
}

/*************************************************************************************************/
/*************************************************************************************************/
void		CopyVideo(char * pDstIn,char * pSrcIn,int w,int h)
{
	int			x,y;
	u_char *		pSrc0=(u_char*)pSrcIn;
	u_char *		pDst0=(u_char*)pDstIn;
	u_char *		pDst;
	u_char *		pSrc;
	u_char			Y0,Y1;
	unsigned int		U,V;

	for(y=0;y<h;y++)
		{
		pSrc=(u_char*)pSrc0;
		pDst=pDst0;
		for(x=0;;)
			{
			U=*pSrc; pSrc++;
			Y0=*pSrc; pSrc++;
			V=*pSrc; pSrc++;
			Y1=*pSrc; pSrc++;
			if (bColorYUV)	{ YUV2RGB(Y0,U,V,pDst); YUV2RGB(Y1,U,V,pDst); }
			else		{ Y2BW(Y0,U,V,pDst); Y2BW(Y1,U,V,pDst); }
			x+=2; if (x>=w) break;
			}
		pSrc0+=w*2;
		pDst0+=w*colorbytes;
		}
}

/*************************************************************************************************/
/*************************************************************************************************/
void		ShowLine0(char * pDstIn,char * pSrcIn,int w,int h)
{
	u_char *		pSrc0=(u_char*)pSrcIn;
	int			x,y;

	memset(pDstIn,0,w*h*colorbytes);
	for(x=0;x<w;x++)
		{ pDstIn[(pSrc0[x*2+1]*w+x)*colorbytes]=0xff;
		pDstIn[(pSrc0[x*2+1]*w+x)*colorbytes+1]=0xff;
		if (colorbytes>2)
			pDstIn[(pSrc0[x*2+1]*w+x)*colorbytes+2]=0xff; }
}

/*************************************************************************************************/
/*************************************************************************************************/
int		GetNewFrame()
{
	if ((bContinous)||(bGrabMode))
		Err=0;
	else	{
		if ((Err=ioctl(fd,ZORAN_CAP_NEW_USER))<0)
			{ printf("ioctl ZORAN_CAP_NEW_USER %i.\n",Err); perror("ioctl"); return(FALSE); }
		if (Err>3) usleep(1000);
		}

	if (Err<4)
		{
		unsigned long		Time;
		if (bOscillo)	ShowLine0(pXImage->data,pScreen+ZRCapParams.TabSlotOffset[Err],width,height);
		else	if (bYUV)	CopyVideo(pXImage->data,pScreen+ZRCapParams.TabSlotOffset[Err],
							width,height);
			else		memcpy(pXImage->data,pScreen+ZRCapParams.TabSlotOffset[Err],
							pXImage->bytes_per_line*height);
		if (bMITShm)	XShmPutImage(dpy,win,gc,pXImage,0,0,0,0,width,height,0);
		else		XPutImage(dpy,win,gc,pXImage,0,0,0,0,width,height);
		NbFrameDrawn++;
		timeval	tv; gettimeofday(&tv,NULL);
		Time=tv.tv_sec*1000+tv.tv_usec/1000;
		if ((Time-StartTime)>TimeWindow)
			{
			fprintf(stderr,"NbFrame=%lu DiffTime=%lu StartTime=%lu Time=%lu\n",
					NbFrameDrawn,Time-StartTime,StartTime,Time);
			fprintf(stderr,"Frame avg= %f\n",(float)NbFrameDrawn*1000/((float)Time-StartTime));
			StartTime=Time; NbFrameDrawn=0;
			}
		}
	return(TRUE);
}

/*************************************************************************************************/
/*************************************************************************************************/
void	VideoExit(void)
{		// call on exit. this way, we are sure to free the shared memory.
	CloseWindow();
	CloseZoran();
}

/*************************************************************************************************/
/*************************************************************************************************/
void		main(int argc,char ** argv)
{
	int		Still=1;
	char		c;

	while ((c=getopt(argc,argv,"z:s:c:m:o:y:b:i:t:w:e:012345x:r:n:u:g:h"))!=EOF)
		switch(c)
			{
			case 'z':	ZoranNB		=atoi(optarg);			break;
			case 's':	bScale		=atoi(optarg);			break;
			case 'c':	bContinous	=atoi(optarg);			break;
			case 'm':	bMITShm		=atoi(optarg);			break;
			case 'o':	bOscillo	=atoi(optarg);			break;
			case 'y':	bYUV		=atoi(optarg);			break;
			case 'b':	bColorYUV	=atoi(optarg);			break;
			case 'i':	Input		=atoi(optarg)+ZORAN_CVBS1;	break;
			case 't':	Standart	=atoi(optarg)+ZORAN_AUTO;	break;
			case 'w':	width		=atoi(optarg);			break;
			case 'e':	height		=atoi(optarg);			break;
			case '0':	width=768; height=576;				break;
			case '1':	width=700; height=555;				break;
			case '2':	width=512; height=384;				break;
			case '3':	width=384; height=288;				break;
			case '4':	width=128; height=96;				break;
			case '5':	width=768; height=288;				break;

			case 'x':	Brightness	=atoi(optarg);			break;
			case 'r':	Chroma		=atoi(optarg);			break;
			case 'n':	Contrast	=atoi(optarg);			break;
			case 'u':	Hue		=atoi(optarg);			break;
			case 'g':	UVGain		=atoi(optarg);			break;
			default:
				printf("video options:\n"
				       "  -z x =zoran id (def 0)\n"
				       "  -s x =scale video (def 0, crop)\n"
				       "  -c x =continous grabing (def 0, synchron)\n"
				       "  -m x =MITSHM (def 0, XImage)\n"
				       "  -o x =Oscillo mode (def 0, video)\n"
				       "  -y x =software YUV to video (def 0, hardware), to be used in 15/16bpp\n"
				       "  -b x =Color YUV to RGB (def 1, RGB)\n"
				       "  -i x =Input (def 2, CVBS2)\n"
				       "  -t x =Standart (def 3, PAL)\n"
				       "  -w x =custom width\n"
				       "  -e x =custom height\n"
				       "  -0   =width=768 height=576\n"
				       "  -1   =width=700 height=556\n"
				       "  -2   =width=512 height=384\n"
				       "  -3   =width=384 height=288\n"
				       "  -4   =width=128 height=96\n"
				       "  -5   =width=768 height=288\n"
				       "  -x x =Brightness (def 210)\n"
				       "  -r x =Chroma (def 127)\n"
				       "  -n x =Contrast (def 102)\n"
				       "  -u x =Hue (def 12)\n"
				       "  -g x =UVGain (def -12)\n"
				       "  -h   =guess what? :)\n");
				exit(0);
			}

	dpy=XOpenDisplay(0);
	if (dpy==NULL) { printf("can' open display."); exit(1); }

	atexit(VideoExit);
	OpenWindow();

	if (InitZoran()==FALSE) goto end;

	while (Still)
		{
		int	bEventQueued=XEventsQueued(dpy,QueuedAlready);
		if (bEventQueued==0)
				{
				XSync(dpy,0);
				bEventQueued=XEventsQueued(dpy,QueuedAlready);
				}
		if (bEventQueued==0)
			{
			if (GetNewFrame()==FALSE) goto end;
			continue;
			}
		
		XNextEvent(dpy,&ev);
		switch (ev.type)
			{
			case Expose :
				break;
			case KeyPress :
				ChangeChannel();
				break;
			case ButtonPress :
				switch(((XButtonEvent*)&ev)->button)
					{
					case 1:
						Still=0;
						FILE * hFile;
/*						hFile=fopen("rgb.raw","w");
						fwrite(pXImage->data,pXImage->bytes_per_line,height,hFile);
						fclose(hFile);*/
//						ioctl(fd,ZORAN_DUMP_REG);
						break;
					case 2:
						bGrabMode=FALSE;
						if (bContinous)
							{ if ((Err=ioctl(fd,ZORAN_CAPMODE_CONTINOUS))<0)
								{ printf("ioctl ZORAN_CAPMODE_CONTINOUS %i.\n",Err); perror("ioctl"); goto end; }
							printf("ioctl ZORAN_CAPMODE_CONTINOUS %i.\n",Err); }
						else	{ if ((Err=ioctl(fd,ZORAN_CAPMODE_3CONTINOUS))<0)
								{ printf("ioctl ZORAN_CAPMODE_3CONTINOUS %i.\n",Err); perror("ioctl"); goto end; }
							printf("ioctl ZORAN_CAPMODE_3CONTINOUS %i.\n",Err); }
						break;
					case 3:
						if (bGrabMode==FALSE)
							{ if (ioctl(fd,ZORAN_CAPMODE_GRAB)<0)
								{ printf("\nzoran: unable to set grab mode.\n"); goto end; }
							bGrabMode=TRUE;
							printf("enter in grab mode\n"); }
						else	{ if (ioctl(fd,ZORAN_CAP_NEW_GRAB)<0)
								{ printf("\nzoran: unable to get new grab.\n"); goto end; }
							printf("new grab ok\n",Contrast); }
						while ((Err=ioctl(fd,ZORAN_CAP_IS_GRAB))==0) usleep(100);
						if (Err<0)
							{ printf("\nzoran: error with ZORAN_CAP_IS_GRAB.\n"); goto end; }
						break;
					}
				break;
			case ButtonRelease :
				break;
			case MotionNotify :
				break;
			case FocusIn:
				break;
			case FocusOut:
				break;
			default :
				break;
			}
		}
end:
	exit(0);	// will call VideoExit
}
